/*ArtBase*/  
/*Create ArtBase DB of the actual Playlist*/
OPTIONS RESULTS
IF ~SHOW("PORTS",MODEXPLORER)												/*Check if ModExplorer is running*/
THEN DO 
	SAY "ModExplorer is not running!!" 
	EXIT																		/*Exit, if ModExplorer is not running*/
END

ADDRESS MODEXPLORER
STOP																		/*Stop ModExplorer from playing music*/
SLEEP ON																		/*Set ModExplorers GUI to sleep*/
GUITITLE "ArtBase Export Script"													/*Set GUI title*/
GUIGAUGE 0																	/*Set gaugevalue to zero*/
GUIGAUGETITLE "Working:"														/*Set gauge title*/
GUIGAUGE OPEN																/*Open gauge*/
GUICOMMAND CLEAR															/*Clear Command list*/
GUICOMMANDTITLE "Work in progress..."											/*Set Command title*/										
GUICOMMAND OPEN															/*Open Command list*/

SYSTEMREQUEST "This Script prepares the playlist for ArtBase. Ok|Cancel"					/*Open Description Request*/
if RESULT=0 THEN  CALL p_exit													/*Call p_exit, when user aborts*/

SAVEPATH																	/*Get actual saving path of ModExplorer*/
stdsavepath=RESULT															/*And save that value for later reset*/
AUTOPLAY																	/*Get actual autoplay setting*/
stdautoplay=RESULT															/*And save that value for later reset*/

PATHREQUEST "Bitte Verzeichnis fr das Projekt auswhlen!"
if result="" then Call p_exit														/*Call p_exit, when user aborts*/
c=0																			/*Check the last character of selected pathname*/
IF RIGHT(RESULT,1)="/" then c=1													/*If it is an "/" */
IF RIGHT(RESULT,1)=":" then c=1													/*Or an ":"*/
IF c=0 then RESULT=RESULT"/"													/*Append an "/" to it*/
modpath='"'result'Modules"'														/*sets a path according to RESULT*/
modpathname=RESULT															/*sets a path according to RESULT*/
instpath='"'result'Instruments"'													/*sets a path according to RESULT*/
tabelle=result 'ModExplorer.CSV'													/*sets a path according to RESULT*/
tabelle1=result'Instruments'														/*sets a path according to RESULT*/

ADDRESS COMMAND
MakeDir modpath																/*Creates a drawer for the modules*/
MakeDir instpath																/*Creates a drawer for the instrument files*/

ADDRESS MODEXPLORER
GUI OPEN																		/*Opens the GUI*/
OPEN(ab_table,tabelle,"W")														/*Creteates a csv-table for ArtBase*/

SAVEPATH modpath															/*Set savingpath for the modules*/
AUTOPLAY OFF																/*Disable autoplaying functin of ModExplorer*/
SELECTLIST PLAYLIST															/*Select the playlist*/
LISTENTRIES																	/*Get number of entries of the playlist*/
plentries=result																/*Save that value*/

WRITELN(ab_table,"Number;Name;Path;Length;Instruments;Artist;Genre;Year;Rating;Likes")	/*Write headlines to the CSV-table*/
DO t=0 to plentries-1
	GUIGAUGETITLE "Working: " t "/" plentries										/*Change gauge title*/
	GUIGAUGE 100/plentries*(t+1)												/*Set new value to the gauge*/
	TRACKNUMBER t															/*Set Tracknumber to loop number*/
	OPEN																	/*Download that track*/

	MODNAME																/*Get Modulename*/
	pname=RESULT															/*And save it into plname*/
	MODLEN																	/*Get Module length*/
	plength=RESULT															/*And save it to plength*/
	ARTIST																	/*Get artist name*/
	partist=RESULT															/*And save it to partist*/
	GENRE																	/*Get Module genre*/
	pgenre=RESULT															/*And save it to pgenre*/
	YEAR																	/*Get module year*/
	pyear=RESULT																/*And save it to pyear*/
	RATING																	/*Get Module rating*/
	prating=RESULT															/*And save it to prating*/
	LIKES																	/*Get Module likes*/
	plikes=RESULT															/*And save it to plikes*/

	GUICOMMAND  pname														/*Set new entry called pname to guicommand list*/
	RECORD																	/*Save actual mod*/

	WRITELN(ab_table,t";"pname";"modpathname'Mods/'pname";"length";"modpathname"Instruments/"pname".txt;"partist";"pgenre";"pyear";"prating";"plikes)
																			/*Writes Module-Information to csv-table*/
	OPEN(Instr,tabelle1"/"pname".txt","W")										/*Open a file for the instrument list of this mod*/

	DO t1=0 to 30
		INSTRUMENT t1
		WRITELN(Instr,t1":" RESULT)												/*Write instrument list to that file*/
	END
	CLOSE(Instr)																/*And close the file again*/		
END																			/*Repeat loop...*/
SYSTEMREQUEST "Playlist erfolgreich exportiert! OK"									/*Request succeeded execution of the script*/
CALL standard																	/*Jump to function 'standard'*/

p_exit:
SYSTEMREQUE	ST "Script Abgebrochen OK"											/*Confirm user abort*/
CALL standard																	/*Jump to function 'standard'*/											

standard:
GUI CLOSE																	/*Close the GUI*/
AUTOPLAY stdautoplay															/*Set autoplay to default value*/
SAVEPATH stdsavepath															/*Set Savepath to default settings*/
EXIT																			/*Exit this script*/